#include <WindowsConstants.au3>
#include "_ArrayEx.au3"
#include "_GUIRegisterMsg.au3"
#include-once
; events are "EN_XXXXXX" in #include <EditConstants.au3>

Enum $__ONEVENT_HWND,			$__ONEVENT_FUNC,		$__ONEVENT_EVENTS,		$__ONEVENT_MAX
Enum $__ONEVENTVANILLA_HWND,	$__ONEVENTVANILLA_FUNC,	$__ONEVENTVANILLA_MAX

Global $__onEventItems[0][$__ONEVENT_MAX]
Global $__onEventVanillaItems[0][$__ONEVENT_MAX]

Func _GUICtrlSetOnEventVanilla($hwnd, $func)
	Return GUICtrlSetOnEvent($hwnd, $func)
EndFunc


Func _GUICtrlSetOnEvent($hwnd, $event, $func = Null)
	If(IsFunc($event)) Then
		_GUICtrlSetOnEventVanilla($hwnd, $event)
	Else
		If($func == Null) Then
			_GUICtrlUnsetOnEvent($hwnd, $event)
		Else
			If(Not(IsHWnd($hwnd))) Then
				$hwnd = GUICtrlGetHandle($hwnd)
			EndIf
			If($hwnd = 0) Then
				Return SetError(1, 0, False)
			EndIf
			Local $oldNb = UBound($__onEventItems, 1)
			Local $index = _Array_FindDouble2D($__onEventItems, $hwnd, $__ONEVENT_HWND, $func, $__ONEVENT_FUNC)
			Local $tabEvent[1] = [$event]
			If($index = -1) Then
				_Array_Add($__onEventItems, _AsArray($hwnd, $func, $tabEvent))
				If($oldNb == 0) Then
					_GUIRegisterMsg($WM_COMMAND, __ControlEvent_WM_COMMAND)
				EndIf
			Else
				$tabEvent = $__onEventItems[$index][2]
				If(_Array_Find1D($tabEvent, $event) = -1) Then
					ReDim $tabEvent[UBound($tabEvent, 1)+1]
					$tabEvent[UBound($tabEvent, 1)-1] = $event
					$__onEventItems[$index][$__ONEVENT_EVENTS] = $tabEvent
				EndIf
				ReDim $__onEventItems[UBound($__onEventItems, 1)+1][UBound($__onEventItems, 2)]
			EndIf
		EndIf
	EndIf
EndFunc

Func _GUICtrlUnsetOnEvent($hwnd, $event)
	If(Not(IsHWnd($hwnd))) Then
		$hwnd = GUICtrlGetHandle($hwnd)
	EndIf
	If($hwnd = 0) Then
		Return SetError(1, 0, False)
	EndIf
	Local $index = __Control_GetItemsByHwndAndEvent($hwnd, $event)
	If($index >= 0) Then
		Local $tabEvent = $__onEventItems[$index][$__ONEVENT_EVENTS]
		Local $indice = _Array_Find1D($tabEvent, $event)
		_Array_Delete($tabEvent, $indice)
		$__onEventItems[$index][$__ONEVENT_EVENTS] = $tabEvent
		If(UBound($tabEvent, 1) == 0) Then
			_Array_Delete($__onEventItems, $index)
			If(UBound($__onEventItems, 1) == 0) Then
				_GUIUnRegisterMsg($WM_COMMAND, __ControlEvent_WM_COMMAND)
			EndIf
		EndIf
	EndIf
EndFunc

Func __Control_GetItemsByHwndAndEvent($hwnd, $event)
	Local $retour = -1
	For $i = 0 To UBound($__onEventItems, 1)-1
		If($__onEventItems[$i][$__ONEVENT_HWND] = $hwnd) Then
			Local $tabEvent = $__onEventItems[$i][$__ONEVENT_EVENTS]
			For $j = 0 To UBound($tabEvent, 1)-1
				If($tabEvent[$j] = $event) Then
					$retour = $i
					ExitLoop 2
				EndIf
			Next
		EndIf
	Next
	Return $retour
EndFunc

Func __ControlEvent_WM_COMMAND($hwnd, $msg, $wParam, $lParam)
    Local $iEvent = BitShift($wParam, 16)
    Local $nID = BitAND($wParam, 0x0000FFFF)
	Local $cible = _Array_FindAll($__onEventItems, $lParam, $__ONEVENT_HWND)
	If(UBound($cible, 1) > 0) Then
		For $i = 0 To UBound($cible, 1)-1
			Local $tabEvent = $__onEventItems[$cible[$i]][$__ONEVENT_EVENTS]
			For $j = 0 To UBound($tabEvent, 1)-1
				If($iEvent = $tabEvent[$j]) Then
					$__onEventItems[$cible[$i]][$__ONEVENT_FUNC]($hwnd, $iEvent, $lParam)
				EndIf
			Next
		Next
	EndIf
	Return $GUI_RUNDEFMSG
EndFunc
