#include-once
#include <GUIConstantsEx.au3>
#include "_ArrayEx.au3"

Global $UDF_GUIRegisterMsg[0][2]
Global $UDF_ListeRegisters[0]

;===============================================================================
; Nom:								  _GUIRegisterMsg()
; Description:						  Associe un venement  une fonction
; Paramtres:    	$hwnd			: Message  associer
;					$enable			: Fonction associe
;
; Auteur:		TommyDDR
;===============================================================================
Func _GUIRegisterMsg($msg, $fonction)
	;Si la fonction n'a pas encore t register pour le message donn
	If(__GUIRegisterGetRegister($msg, $fonction) = -1) Then
		;On ajoute la fonction et le message dans la liste
		__GUIRegisterAddMsg($msg)
		_Array_Add($UDF_GUIRegisterMsg, _AsArray($msg, $fonction))
	EndIf
EndFunc

;===============================================================================
; Nom:								  _GUIRegisterMsg()
; Description:						  Supprimer l'association d'un venement  une fonction
; Paramtres:    	$hwnd			: Message  ne plus associer
;					$enable			: Fonction qui tait associe
;
; Auteur:		TommyDDR
;===============================================================================
Func _GUIUnRegisterMsg($msg, $fonction)
	Local $numero = __GUIRegisterGetRegister($msg, $fonction)
	; Si la fonction associe au message existe
	If($numero >= 0) Then
		; On la supprime de la liste
		__GUIRegisterDelRegister($numero)
	EndIf
EndFunc

Func __GUIRegisterAddMsg($msg)
	; Si le message n'a pas encore t register
	If(_Array_Find1D($UDF_ListeRegisters, $msg) = -1) Then
		_Array_Add($UDF_ListeRegisters, $msg)
		GUIRegisterMsg($msg, "__Func_GUIRegisterMsg")
	EndIf
EndFunc

Func __Func_GUIRegisterMsg($hWnd, $msg, $wParam, $lParam)
	Local $return = $GUI_RUNDEFMSG
	Local $returnBis
	For $i = 0 To UBound($UDF_GUIRegisterMsg, 1)-1
		If($i >= UBound($UDF_GUIRegisterMsg, 1)) Then ExitLoop
		If($UDF_GUIRegisterMsg[$i][0] = $msg) Then
			$returnBis = Call($UDF_GUIRegisterMsg[$i][1], $hWnd, $msg, $wParam, $lParam)
			If($returnBis <> $GUI_RUNDEFMSG) Then
				$return = $returnBis
			EndIf
		EndIf
	Next
	Return $return
EndFunc

Func __GUIRegisterGetRegister($msg, $fonction)
	Return _Array_FindDouble2D($UDF_GUIRegisterMsg, $msg, 0, $fonction, 1)
EndFunc

Func __GUIRegisterDelRegister($numero)
	For $i = $numero To UBound($UDF_GUIRegisterMsg, 1)-2
		$UDF_GUIRegisterMsg[$i][0] = $UDF_GUIRegisterMsg[$i+1][0]
		$UDF_GUIRegisterMsg[$i][1] = $UDF_GUIRegisterMsg[$i+1][1]
	Next
	ReDim $UDF_GUIRegisterMsg[UBound($UDF_GUIRegisterMsg, 1)-1][UBound($UDF_GUIRegisterMsg, 2)]
EndFunc
